﻿namespace App287
{
  using System;
  using Windows.UI;
  using Windows.UI.Xaml;
  using Windows.UI.Xaml.Controls;
  using Windows.UI.Xaml.Input;

  public sealed partial class MainPage : Page
  {
    public MainPage()
    {
      this.InitializeComponent();

      this.drawer = new VisualRectangleDrawer();
      this.drawer.Color = Colors.White;
      this.drawer.DrawCanvas = this.drawCanvas;

      this.timer = new DispatcherTimer();
      this.timer.Interval = TimeSpan.FromMilliseconds(10);
      this.timer.Tick += OnTimerTick;
      this.timer.Start();
    }
    void OnTimerTick(object sender, object e)
    {
      this.txtCount.Text = (++this.ticks).ToString();
    }
    void OnPointerReleased(object sender, PointerRoutedEventArgs e)
    {
      this.drawer.ClearRectangles();

      var sidelength = Math.Sqrt(this.rectangleCount);

      var fullWidth = this.drawCanvas.ActualWidth /
        sidelength;

      var fullHeight = this.drawCanvas.ActualHeight /
        sidelength;

      var horizontalSpacing = 0.25 * fullWidth;
      var verticalSpacing = 0.25 * fullWidth;

      for (int i = 0; i < sidelength; i++)
      {
        for (int j = 0; j < sidelength; j++)
        {
          this.drawer.DrawRectangle(
            (int)((i * fullWidth) + (horizontalSpacing / 2)),
            (int)((j * fullHeight) + (verticalSpacing / 2)),
            (int)(fullWidth * 0.75),
            (int)(fullHeight * 0.75));
        }
      }
      this.rectangleCount *= 4;
    }
    DispatcherTimer timer;
    long ticks;
    IDrawCanvasRectangles drawer;
    int rectangleCount = 1;
  }
}
