﻿namespace App287
{
  using System;
  using Windows.UI;
  using Windows.UI.Xaml.Controls;

  abstract class RectangleDrawer : IDrawCanvasRectangles
  {
    public Color Color { get; set; }
    public Canvas DrawCanvas
    {
      get {
        return (this.drawCanvas);
      }
      set
      {
        if (this.drawCanvas != value)
        {
          this.OnDrawCanvasChanging();
          this.drawCanvas = value;
          this.OnDrawCanvasChanged();
        }
      }
    }
    virtual protected void OnDrawCanvasChanging()
    {
    }
    virtual protected void OnDrawCanvasChanged()
    {
    }
    public abstract void ClearRectangles();
    public abstract void DrawRectangle(int x, int y, int width, int height);

    Canvas drawCanvas;
  }
}
