﻿namespace App287
{
  using System;
  using Windows.Foundation;
  using Windows.UI;
  using Windows.UI.Xaml.Controls;
  using Windows.UI.Xaml.Media;
  using Windows.UI.Xaml.Media.Animation;
  using Windows.UI.Xaml.Shapes;

  class XamlRectangleDrawer : RectangleDrawer
  {
    public override void ClearRectangles()
    {
      this.DrawCanvas.Children.Clear();
    }
    public override void DrawRectangle(int x, int y, int width, int height)
    {
      if (this.FillBrush == null)
      {
        this.FillBrush = new SolidColorBrush(base.Color);
      }
      Rectangle rectangle = new Rectangle()
      {
        Width = width,
        Height = height,
        Fill = FillBrush
      };
      Canvas.SetLeft(rectangle, x);
      Canvas.SetTop(rectangle, y);

      AddSpinAnimationXaml(rectangle);

      this.DrawCanvas.Children.Add(rectangle);
    }
    static void AddSpinAnimationXaml(Rectangle rectangle)
    {
      RotateTransform transform = new RotateTransform();
      rectangle.RenderTransform = transform;
      rectangle.RenderTransformOrigin = new Point(0.5d, 0.5d);

      DoubleAnimation angleAnimation =
        new DoubleAnimation()
        {
          From = 0.0d,
          To = 360
        };

      angleAnimation.EasingFunction = new SineEase();

      Storyboard.SetTarget(angleAnimation, transform);
      Storyboard.SetTargetProperty(angleAnimation, "Angle");

      DoubleAnimation opacityAnimation =
        new DoubleAnimation()
        {
          From = 0.0d,
          To = 1.0d
        };

      opacityAnimation.EasingFunction = new SineEase();

      Storyboard.SetTarget(opacityAnimation, rectangle);
      Storyboard.SetTargetProperty(opacityAnimation, "Opacity");


#if COLOUR_ANIMATIONS
      ColorAnimation colorAnimation =
        new ColorAnimation()
        {
          From = Color.FromArgb(0x55, 0x00, 0x00, 0x00),
          To = Color.FromArgb(0x55, 0xFF, 0xFF, 0xFF)
        };
      Storyboard.SetTarget(colorAnimation, rectangle);
      Storyboard.SetTargetProperty(colorAnimation, "(Shape.Fill).(SolidColorBrush.Color)");
#endif // COLOUR_ANIMATIONS

      Storyboard storyBoard = new Storyboard();
      storyBoard.Duration = TimeSpan.FromSeconds(1);
      storyBoard.RepeatBehavior = RepeatBehavior.Forever;

      storyBoard.Children.Add(angleAnimation);
      storyBoard.Children.Add(opacityAnimation);

#if COLOUR_ANIMATIONS
    storyBoard.Children.Add(colorAnimation);
#endif // COLOUR_ANIMATIONS

      storyBoard.Begin();

    }
    SolidColorBrush FillBrush;
  }
}
